/*
	November 2008 Mark Tyler
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <libmtpixel.h>




#define SWATCH_WIDTH 16

static void create_palette( int p, char *pal_filename, char *img_filename )
{
	int cols = p*p*p, i, r, g, b, w, h, x1, y1, x2, y2;


	w = SWATCH_WIDTH * p * p;
	h = SWATCH_WIDTH * p;

	mtpaint_new_image( w, h, cols, 0, 1 );

	for ( i=0; i<cols; i++ )
	{
		r = 255 * (i % p) / (p - 1);
		g = 255 * ((i/p) % p) / (p - 1);
		b = 255 * ((i/(p*p)) % p) / (p - 1);
		mtpaint_palette_set( i, r, g, b );

		x1 = SWATCH_WIDTH * (i % p) + p * SWATCH_WIDTH * (i / (p*p));
		y1 = SWATCH_WIDTH * ((i / p) % p);
		x2 = x1 + SWATCH_WIDTH - 1;
		y2 = y1 + SWATCH_WIDTH - 1;
		mtpaint_col_a( i );
		mtpaint_rectangle( x1, y1, x2, y2, 0 );
	}

	mtpaint_palette_save( pal_filename );
	mtpaint_file_save( img_filename, FT_PNG, 9 );
}


int main( int argc, char *argv[] )
{
	mtpaint_init();

	create_palette( 3, "pal_3x3x3.gpl", "pal_3x3x3.png" );
	create_palette( 4, "pal_4x4x4.gpl", "pal_4x4x4.png" );
	create_palette( 5, "pal_5x5x5.gpl", "pal_5x5x5.png" );
	create_palette( 6, "pal_6x6x6.gpl", "pal_6x6x6.png" );

	mtpaint_quit();

	return 0;
}
